// MyToggleWnd.cpp : implementation file
//

#include "stdafx.h"
#include "pe_test_prog.h"
#include "MyToggleWnd.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMyToggleWnd

CMyToggleWnd::CMyToggleWnd()
{
	m_bState = false;
	m_clr = GetSysColor(0);
	m_clrOn = RGB(0, 255, 0);
	m_sOnText = "ON";
	m_sOffText = "OFF";
}

CMyToggleWnd::~CMyToggleWnd()
{
}


BEGIN_MESSAGE_MAP(CMyToggleWnd, CWnd)
	//{{AFX_MSG_MAP(CMyToggleWnd)
	ON_WM_PAINT()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CMyToggleWnd message handlers

void CMyToggleWnd::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	
	CRect rcClient;
	GetClientRect(rcClient);

	m_clr = m_bState ? m_clrOn : GetSysColor(0);
	dc.FillSolidRect(rcClient, m_clr);

	CString sState = m_bState ? m_sOnText : m_sOffText;
	dc.TextOut(10, 3, sState);
}

void CMyToggleWnd::SetState(bool bOn)
{
	m_bState = bOn;
	Invalidate();
}

void CMyToggleWnd::SetOnColor(COLORREF clr)
{
	m_clrOn = clr;
}

bool CMyToggleWnd::GetBtnState()
{
	return m_bState;
}

void CMyToggleWnd::SetToggleText(CString sOnText, CString sOffText)
{
	m_sOnText = sOnText;
	m_sOffText = sOffText;
}
