// PE_TEST_PROGDlg.cpp : implementation file
//

#include "stdafx.h"
#include "PE_TEST_PROG.h"
#include "PE_TEST_PROGDlg.h"

#include <direct.h>

#include <mmsystem.h>

#include "include/ceSDK.h"
#include "include/ceSDKDef.h"

#pragma comment (lib, "winmm.lib")

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

enum {IGT_NODEINFO, IGT_AIO};
enum {TM_ODD, TM_EVEN, TM_ALLON, TM_ALLOFF};

TNodeInformation g_CurrentNodeInformation;

long g_nTot0032 = 0;
long g_nTot3200 = 0;
long g_nTot0024 = 0;
long g_nTot0016 = 0;
long g_nTot1600 = 0;
long g_nTot1616 = 0;
long g_nTot0808 = 0;

long g_nTotNodes = 0;
long g_nTotCM01A = 0;
long g_nTotCNetSlaves = 0;
long g_nTotnDiChNum = 0;
long g_nTotnDoChNum = 0;

BOOL g_bIsAdStarted = FALSE;
BOOL g_bIsToggleLed = FALSE;

UINT g_uToggleMode = TM_ALLOFF;

//ULONG g_uCount=0, g_uManCount=0;
BOOL g_bThreadStop = TRUE;//, g_bManThreadStop = TRUE;

#define MAX_IOSENSOR_PORT		15
#define MAX_LEAKINTERLOCK		6
#define MAX_TRIPRELAY			3

#define TIMER_INTV				10
int g_nCheckIntv = 1000;
ULONG g_uTimerCount = 0;

int g_nDurationInMSec=5000;

// α
CString g_sCurLog("-");
BOOL g_bNewLog=FALSE;

CString g_sLogFolder("LOG");

// Ƽ̵ Ÿ̸ 

// Ÿ̸ ڵ鷯 
MMRESULT g_idEvent1;

int g_nOutStart=0, g_nOutEnd=31;
int g_nInStart=0, g_nInEnd=31;

typedef struct _TCNetSlaveInfo
{
	int nType; // 0:input only, 1:output only, 2:in/out
	int nStartInputCh;
	int nEndInputCh;
	int nStartOutputCh;
	int nEndOutputCh;
	_TCNetSlaveInfo(){
		nType = -1;
		nStartInputCh = -1;
		nEndInputCh = -1;
		nStartOutputCh = -1;
		nEndOutputCh = -1;
	}
} TCNetSlaveInfo;

#define MAX_MOD	128   // ִ CNET Slave   128 .

TCNetSlaveInfo g_tCNetSlaveInfo[MAX_MOD];

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About
class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPE_TEST_PROGDlg dialog

CPE_TEST_PROGDlg::CPE_TEST_PROGDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPE_TEST_PROGDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPE_TEST_PROGDlg)
	m_DiState = _T("");
	m_DoState = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CPE_TEST_PROGDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPE_TEST_PROGDlg)
	DDX_Control(pDX, IDC_CNETDO_GRP, m_grpCnetDo);
	DDX_Control(pDX, IDC_CNETDI_GRP, m_grpCnetDi);
	DDX_Control(pDX, IDC_TREE_NODEINFO, m_treeNodeInfo);
	DDX_Control(pDX, IDC_LED00, m_ledCh00);
	DDX_Control(pDX, IDC_LED01, m_ledCh01);
	DDX_Control(pDX, IDC_LED02, m_ledCh02);
	DDX_Control(pDX, IDC_LED03, m_ledCh03);
	DDX_Control(pDX, IDC_LED04, m_ledCh04);
	DDX_Control(pDX, IDC_LED05, m_ledCh05);
	DDX_Control(pDX, IDC_LED06, m_ledCh06);
	DDX_Control(pDX, IDC_LED07, m_ledCh07);
	DDX_Control(pDX, IDC_LED08, m_ledCh08);
	DDX_Control(pDX, IDC_LED09, m_ledCh09);
	DDX_Control(pDX, IDC_LED10, m_ledCh10);
	DDX_Control(pDX, IDC_LED11, m_ledCh11);
	DDX_Control(pDX, IDC_LED12, m_ledCh12);
	DDX_Control(pDX, IDC_LED13, m_ledCh13);
	DDX_Control(pDX, IDC_LED14, m_ledCh14);
	DDX_Control(pDX, IDC_LED15, m_ledCh15);
	DDX_Control(pDX, IDC_LED16, m_ledCh16);
	DDX_Control(pDX, IDC_LED17, m_ledCh17);
	DDX_Control(pDX, IDC_LED18, m_ledCh18);
	DDX_Control(pDX, IDC_LED19, m_ledCh19);
	DDX_Control(pDX, IDC_LED20, m_ledCh20);
	DDX_Control(pDX, IDC_LED21, m_ledCh21);
	DDX_Control(pDX, IDC_LED22, m_ledCh22);
	DDX_Control(pDX, IDC_LED23, m_ledCh23);
	DDX_Control(pDX, IDC_LED24, m_ledCh24);
	DDX_Control(pDX, IDC_LED25, m_ledCh25);
	DDX_Control(pDX, IDC_LED26, m_ledCh26);
	DDX_Control(pDX, IDC_LED27, m_ledCh27);
	DDX_Control(pDX, IDC_LED28, m_ledCh28);
	DDX_Control(pDX, IDC_LED29, m_ledCh29);
	DDX_Control(pDX, IDC_LED30, m_ledCh30);
	DDX_Control(pDX, IDC_LED31, m_ledCh31);
	DDX_Control(pDX, IDC_TGBTN00, m_btnCh00);
	DDX_Control(pDX, IDC_TGBTN01, m_btnCh01);
	DDX_Control(pDX, IDC_TGBTN02, m_btnCh02);
	DDX_Control(pDX, IDC_TGBTN03, m_btnCh03);
	DDX_Control(pDX, IDC_TGBTN04, m_btnCh04);
	DDX_Control(pDX, IDC_TGBTN05, m_btnCh05);
	DDX_Control(pDX, IDC_TGBTN06, m_btnCh06);
	DDX_Control(pDX, IDC_TGBTN07, m_btnCh07);
	DDX_Control(pDX, IDC_TGBTN08, m_btnCh08);
	DDX_Control(pDX, IDC_TGBTN09, m_btnCh09);
	DDX_Control(pDX, IDC_TGBTN10, m_btnCh10);
	DDX_Control(pDX, IDC_TGBTN11, m_btnCh11);
	DDX_Control(pDX, IDC_TGBTN12, m_btnCh12);
	DDX_Control(pDX, IDC_TGBTN13, m_btnCh13);
	DDX_Control(pDX, IDC_TGBTN14, m_btnCh14);
	DDX_Control(pDX, IDC_TGBTN15, m_btnCh15);
	DDX_Control(pDX, IDC_TGBTN16, m_btnCh16);
	DDX_Control(pDX, IDC_TGBTN17, m_btnCh17);
	DDX_Control(pDX, IDC_TGBTN18, m_btnCh18);
	DDX_Control(pDX, IDC_TGBTN19, m_btnCh19);
	DDX_Control(pDX, IDC_TGBTN20, m_btnCh20);
	DDX_Control(pDX, IDC_TGBTN21, m_btnCh21);
	DDX_Control(pDX, IDC_TGBTN22, m_btnCh22);
	DDX_Control(pDX, IDC_TGBTN23, m_btnCh23);
	DDX_Control(pDX, IDC_TGBTN24, m_btnCh24);
	DDX_Control(pDX, IDC_TGBTN25, m_btnCh25);
	DDX_Control(pDX, IDC_TGBTN26, m_btnCh26);
	DDX_Control(pDX, IDC_TGBTN27, m_btnCh27);
	DDX_Control(pDX, IDC_TGBTN28, m_btnCh28);
	DDX_Control(pDX, IDC_TGBTN29, m_btnCh29);
	DDX_Control(pDX, IDC_TGBTN30, m_btnCh30);
	DDX_Control(pDX, IDC_TGBTN31, m_btnCh31);
	DDX_Text(pDX, IDC_STC_DI, m_DiState);
	DDX_Text(pDX, IDC_STC_DO, m_DoState);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CPE_TEST_PROGDlg, CDialog)
	//{{AFX_MSG_MAP(CPE_TEST_PROGDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_TIMER()
	ON_WM_DESTROY()
	ON_NOTIFY(TVN_SELCHANGED, IDC_TREE_NODEINFO, OnSelchangedTreeNodeinfo)
	ON_WM_CLOSE()
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPE_TEST_PROGDlg message handlers

BOOL CPE_TEST_PROGDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	int i=0;

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// ̺귯  ̽ ε
	if(!ceLoadDll())
	{
		AfxMessageBox("ceSDKDLL.DLL  ε !");
		return FALSE;
	}

	if(ceGnLoad() != ceERR_NONE)
	{
		AfxMessageBox("cEIP Device ε !");
		return FALSE;
	}

	//OnMouseUpTgbtnResetnodeinfo();
	InitGui(IGT_NODEINFO);

	SetTimer(0, TIMER_INTV, NULL);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CPE_TEST_PROGDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CPE_TEST_PROGDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CPE_TEST_PROGDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CPE_TEST_PROGDlg::OnTimer(UINT nIDEvent) 
{
	CString sData;
	if(g_nTotCNetSlaves > 0){
		if(g_nTotnDiChNum > 0)
		{
			// CNET Di  ǥ
			long nState;
			CCOMILed *pMyLed = NULL;

			for(int i=0; i<32; i++){
				cecnetDIOne_Get(g_nInStart+i, &nState);
				GetLedFromIdx(i, pMyLed);

				if(nState == 0){
					pMyLed->SetStateColor(0x10D8E9EC);
				}else{
					pMyLed->SetStateColor(0x0000FF00);
				}
			}
		}

		if(g_bIsToggleLed)
		{
			if(g_uToggleMode == TM_ODD) OnMouseUpTgbtnEven(0,0,0,0);
			else if(g_uToggleMode == TM_EVEN) OnMouseUpTgbtnOdd(0,0,0,0);
			else if(g_uToggleMode == TM_ALLON) OnMouseUpTgbtnAlloff(0,0,0,0);
			else if(g_uToggleMode == TM_ALLOFF) OnMouseUpTgbtnAllon(0,0,0,0);
		}
	}

	if(!g_bIsAdStarted)
	{
		return;
	}

	CDialog::OnTimer(nIDEvent);
}

BEGIN_EVENTSINK_MAP(CPE_TEST_PROGDlg, CDialog)
    //{{AFX_EVENTSINK_MAP(CPE_TEST_PROGDlg)
	ON_EVENT(CPE_TEST_PROGDlg, IDC_TGBTN_RESETNODEINFO, -607 /* MouseUp */, OnMouseUpTgbtnResetnodeinfo, VTS_I2 VTS_I2 VTS_I4 VTS_I4)
	ON_EVENT(CPE_TEST_PROGDlg, IDC_TGBTN_ODD, -607 /* MouseUp */, OnMouseUpTgbtnOdd, VTS_I2 VTS_I2 VTS_I4 VTS_I4)
	ON_EVENT(CPE_TEST_PROGDlg, IDC_TGBTN_EVEN, -607 /* MouseUp */, OnMouseUpTgbtnEven, VTS_I2 VTS_I2 VTS_I4 VTS_I4)
	ON_EVENT(CPE_TEST_PROGDlg, IDC_TGBTN_ALLON, -607 /* MouseUp */, OnMouseUpTgbtnAllon, VTS_I2 VTS_I2 VTS_I4 VTS_I4)
	ON_EVENT(CPE_TEST_PROGDlg, IDC_TGBTN_ALLOFF, -607 /* MouseUp */, OnMouseUpTgbtnAlloff, VTS_I2 VTS_I2 VTS_I4 VTS_I4)
	ON_EVENT(CPE_TEST_PROGDlg, IDC_TGBTN_QUIT, -607 /* MouseUp */, OnMouseUpTgbtnQuit, VTS_I2 VTS_I2 VTS_I4 VTS_I4)
	ON_EVENT(CPE_TEST_PROGDlg, IDC_SCANNODE, -607 /* MouseUp */, OnMouseUpScannode, VTS_I2 VTS_I2 VTS_I4 VTS_I4)
	ON_EVENT(CPE_TEST_PROGDlg, IDC_TGBTN00, -607 /* MouseUp */, OnMouseUpTgbtn00, VTS_I2 VTS_I2 VTS_I4 VTS_I4)
	ON_EVENT(CPE_TEST_PROGDlg, IDC_TGBTN01, -607 /* MouseUp */, OnMouseUpTgbtn01, VTS_I2 VTS_I2 VTS_I4 VTS_I4)
	ON_EVENT(CPE_TEST_PROGDlg, IDC_TGBTN02, -607 /* MouseUp */, OnMouseUpTgbtn02, VTS_I2 VTS_I2 VTS_I4 VTS_I4)
	ON_EVENT(CPE_TEST_PROGDlg, IDC_TGBTN03, -607 /* MouseUp */, OnMouseUpTgbtn03, VTS_I2 VTS_I2 VTS_I4 VTS_I4)
	ON_EVENT(CPE_TEST_PROGDlg, IDC_TGBTN04, -607 /* MouseUp */, OnMouseUpTgbtn04, VTS_I2 VTS_I2 VTS_I4 VTS_I4)
	ON_EVENT(CPE_TEST_PROGDlg, IDC_TGBTN05, -607 /* MouseUp */, OnMouseUpTgbtn05, VTS_I2 VTS_I2 VTS_I4 VTS_I4)
	ON_EVENT(CPE_TEST_PROGDlg, IDC_TGBTN06, -607 /* MouseUp */, OnMouseUpTgbtn06, VTS_I2 VTS_I2 VTS_I4 VTS_I4)
	ON_EVENT(CPE_TEST_PROGDlg, IDC_TGBTN07, -607 /* MouseUp */, OnMouseUpTgbtn07, VTS_I2 VTS_I2 VTS_I4 VTS_I4)
	ON_EVENT(CPE_TEST_PROGDlg, IDC_TGBTN08, -607 /* MouseUp */, OnMouseUpTgbtn08, VTS_I2 VTS_I2 VTS_I4 VTS_I4)
	ON_EVENT(CPE_TEST_PROGDlg, IDC_TGBTN09, -607 /* MouseUp */, OnMouseUpTgbtn09, VTS_I2 VTS_I2 VTS_I4 VTS_I4)
	ON_EVENT(CPE_TEST_PROGDlg, IDC_TGBTN10, -607 /* MouseUp */, OnMouseUpTgbtn10, VTS_I2 VTS_I2 VTS_I4 VTS_I4)
	ON_EVENT(CPE_TEST_PROGDlg, IDC_TGBTN11, -607 /* MouseUp */, OnMouseUpTgbtn11, VTS_I2 VTS_I2 VTS_I4 VTS_I4)
	ON_EVENT(CPE_TEST_PROGDlg, IDC_TGBTN12, -607 /* MouseUp */, OnMouseUpTgbtn12, VTS_I2 VTS_I2 VTS_I4 VTS_I4)
	ON_EVENT(CPE_TEST_PROGDlg, IDC_TGBTN13, -607 /* MouseUp */, OnMouseUpTgbtn13, VTS_I2 VTS_I2 VTS_I4 VTS_I4)
	ON_EVENT(CPE_TEST_PROGDlg, IDC_TGBTN14, -607 /* MouseUp */, OnMouseUpTgbtn14, VTS_I2 VTS_I2 VTS_I4 VTS_I4)
	ON_EVENT(CPE_TEST_PROGDlg, IDC_TGBTN15, -607 /* MouseUp */, OnMouseUpTgbtn15, VTS_I2 VTS_I2 VTS_I4 VTS_I4)
	ON_EVENT(CPE_TEST_PROGDlg, IDC_TGBTN16, -607 /* MouseUp */, OnMouseUpTgbtn16, VTS_I2 VTS_I2 VTS_I4 VTS_I4)
	ON_EVENT(CPE_TEST_PROGDlg, IDC_TGBTN17, -607 /* MouseUp */, OnMouseUpTgbtn17, VTS_I2 VTS_I2 VTS_I4 VTS_I4)
	ON_EVENT(CPE_TEST_PROGDlg, IDC_TGBTN18, -607 /* MouseUp */, OnMouseUpTgbtn18, VTS_I2 VTS_I2 VTS_I4 VTS_I4)
	ON_EVENT(CPE_TEST_PROGDlg, IDC_TGBTN19, -607 /* MouseUp */, OnMouseUpTgbtn19, VTS_I2 VTS_I2 VTS_I4 VTS_I4)
	ON_EVENT(CPE_TEST_PROGDlg, IDC_TGBTN20, -607 /* MouseUp */, OnMouseUpTgbtn20, VTS_I2 VTS_I2 VTS_I4 VTS_I4)
	ON_EVENT(CPE_TEST_PROGDlg, IDC_TGBTN21, -607 /* MouseUp */, OnMouseUpTgbtn21, VTS_I2 VTS_I2 VTS_I4 VTS_I4)
	ON_EVENT(CPE_TEST_PROGDlg, IDC_TGBTN22, -607 /* MouseUp */, OnMouseUpTgbtn22, VTS_I2 VTS_I2 VTS_I4 VTS_I4)
	ON_EVENT(CPE_TEST_PROGDlg, IDC_TGBTN23, -607 /* MouseUp */, OnMouseUpTgbtn23, VTS_I2 VTS_I2 VTS_I4 VTS_I4)
	ON_EVENT(CPE_TEST_PROGDlg, IDC_TGBTN24, -607 /* MouseUp */, OnMouseUpTgbtn24, VTS_I2 VTS_I2 VTS_I4 VTS_I4)
	ON_EVENT(CPE_TEST_PROGDlg, IDC_TGBTN25, -607 /* MouseUp */, OnMouseUpTgbtn25, VTS_I2 VTS_I2 VTS_I4 VTS_I4)
	ON_EVENT(CPE_TEST_PROGDlg, IDC_TGBTN26, -607 /* MouseUp */, OnMouseUpTgbtn26, VTS_I2 VTS_I2 VTS_I4 VTS_I4)
	ON_EVENT(CPE_TEST_PROGDlg, IDC_TGBTN27, -607 /* MouseUp */, OnMouseUpTgbtn27, VTS_I2 VTS_I2 VTS_I4 VTS_I4)
	ON_EVENT(CPE_TEST_PROGDlg, IDC_TGBTN28, -607 /* MouseUp */, OnMouseUpTgbtn28, VTS_I2 VTS_I2 VTS_I4 VTS_I4)
	ON_EVENT(CPE_TEST_PROGDlg, IDC_TGBTN29, -607 /* MouseUp */, OnMouseUpTgbtn29, VTS_I2 VTS_I2 VTS_I4 VTS_I4)
	ON_EVENT(CPE_TEST_PROGDlg, IDC_TGBTN30, -607 /* MouseUp */, OnMouseUpTgbtn30, VTS_I2 VTS_I2 VTS_I4 VTS_I4)
	ON_EVENT(CPE_TEST_PROGDlg, IDC_TGBTN31, -607 /* MouseUp */, OnMouseUpTgbtn31, VTS_I2 VTS_I2 VTS_I4 VTS_I4)
	//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()

void CPE_TEST_PROGDlg::InitGui(UINT uType)
{
	CString sVal;

	//  ˻ â ʱȭ
	if(uType == IGT_NODEINFO){
		m_treeNodeInfo.DeleteAllItems();

		TVINSERTSTRUCT tvi;
		tvi.hParent = TVI_ROOT;
		tvi.hInsertAfter = TVI_LAST;
		tvi.item.mask = TVIF_TEXT;
		tvi.item.pszText = "Node: 0.0.0.0";

		HTREEITEM hTreeRoot = m_treeNodeInfo.InsertItem(&tvi);

		tvi.hParent = hTreeRoot;
		tvi.hInsertAfter = TVI_LAST;
		tvi.item.mask = TVIF_TEXT;
		tvi.item.pszText = "ĵ ";
		m_treeNodeInfo.InsertItem(&tvi);

		m_treeNodeInfo.Expand(hTreeRoot, TVE_EXPAND);		
	}	

	UpdateChannelView();
}

void CPE_TEST_PROGDlg::OnMouseUpTgbtnResetnodeinfo(short Button, short Shift, long x, long y) 
{
	InitGui(IGT_NODEINFO);
}


void CPE_TEST_PROGDlg::OnMouseUpTgbtn00(short Button, short Shift, long x, long y) 
{
	CComiToggleSwitch *pBtn = NULL;
	GetBtnFromIdx(0, pBtn);
	int nState = pBtn->GetState();

	cecnetOne_Put(g_nOutStart+0, nState);
}

void CPE_TEST_PROGDlg::OnMouseUpTgbtn01(short Button, short Shift, long x, long y) 
{
	CComiToggleSwitch *pBtn = NULL;
	GetBtnFromIdx(1, pBtn);
	int nState = pBtn->GetState();

	cecnetOne_Put(g_nOutStart+1, nState);
}

void CPE_TEST_PROGDlg::OnMouseUpTgbtn02(short Button, short Shift, long x, long y) 
{
	CComiToggleSwitch *pBtn = NULL;
	GetBtnFromIdx(2, pBtn);
	int nState = pBtn->GetState();

	cecnetOne_Put(g_nOutStart+2, nState);
}

void CPE_TEST_PROGDlg::OnMouseUpTgbtn03(short Button, short Shift, long x, long y) 
{
	CComiToggleSwitch *pBtn = NULL;
	GetBtnFromIdx(3, pBtn);
	int nState = pBtn->GetState();

	cecnetOne_Put(g_nOutStart+3, nState);
}

void CPE_TEST_PROGDlg::OnMouseUpTgbtn04(short Button, short Shift, long x, long y) 
{
	CComiToggleSwitch *pBtn = NULL;
	GetBtnFromIdx(4, pBtn);
	int nState = pBtn->GetState();

	cecnetOne_Put(g_nOutStart+4, nState);
}

void CPE_TEST_PROGDlg::OnMouseUpTgbtn05(short Button, short Shift, long x, long y) 
{
	CComiToggleSwitch *pBtn = NULL;
	GetBtnFromIdx(5, pBtn);
	int nState = pBtn->GetState();

	cecnetOne_Put(g_nOutStart+5, nState);
}

void CPE_TEST_PROGDlg::OnMouseUpTgbtn06(short Button, short Shift, long x, long y) 
{
	CComiToggleSwitch *pBtn = NULL;
	GetBtnFromIdx(6, pBtn);
	int nState = pBtn->GetState();

	cecnetOne_Put(g_nOutStart+6, nState);
}

void CPE_TEST_PROGDlg::OnMouseUpTgbtn07(short Button, short Shift, long x, long y) 
{
	CComiToggleSwitch *pBtn = NULL;
	GetBtnFromIdx(7, pBtn);
	int nState = pBtn->GetState();

	cecnetOne_Put(g_nOutStart+7, nState);
}

void CPE_TEST_PROGDlg::OnMouseUpTgbtn08(short Button, short Shift, long x, long y) 
{
	CComiToggleSwitch *pBtn = NULL;
	GetBtnFromIdx(8, pBtn);
	int nState = pBtn->GetState();

	cecnetOne_Put(g_nOutStart+8, nState);
}

void CPE_TEST_PROGDlg::OnMouseUpTgbtn09(short Button, short Shift, long x, long y) 
{
	CComiToggleSwitch *pBtn = NULL;
	GetBtnFromIdx(9, pBtn);
	int nState = pBtn->GetState();

	cecnetOne_Put(g_nOutStart+9, nState);
}

void CPE_TEST_PROGDlg::OnMouseUpTgbtn10(short Button, short Shift, long x, long y) 
{
	CComiToggleSwitch *pBtn = NULL;
	GetBtnFromIdx(10, pBtn);
	int nState = pBtn->GetState();

	cecnetOne_Put(g_nOutStart+10, nState);
}

void CPE_TEST_PROGDlg::OnMouseUpTgbtn11(short Button, short Shift, long x, long y) 
{
	CComiToggleSwitch *pBtn = NULL;
	GetBtnFromIdx(11, pBtn);
	int nState = pBtn->GetState();

	cecnetOne_Put(g_nOutStart+11, nState);
}

void CPE_TEST_PROGDlg::OnMouseUpTgbtn12(short Button, short Shift, long x, long y) 
{
	CComiToggleSwitch *pBtn = NULL;
	GetBtnFromIdx(12, pBtn);
	int nState = pBtn->GetState();

	cecnetOne_Put(g_nOutStart+12, nState);
}

void CPE_TEST_PROGDlg::OnMouseUpTgbtn13(short Button, short Shift, long x, long y) 
{
	CComiToggleSwitch *pBtn = NULL;
	GetBtnFromIdx(13, pBtn);
	int nState = pBtn->GetState();

	cecnetOne_Put(g_nOutStart+13, nState);
}

void CPE_TEST_PROGDlg::OnMouseUpTgbtn14(short Button, short Shift, long x, long y) 
{
	CComiToggleSwitch *pBtn = NULL;
	GetBtnFromIdx(14, pBtn);
	int nState = pBtn->GetState();

	cecnetOne_Put(g_nOutStart+14, nState);
}

void CPE_TEST_PROGDlg::OnMouseUpTgbtn15(short Button, short Shift, long x, long y) 
{
	CComiToggleSwitch *pBtn = NULL;
	GetBtnFromIdx(15, pBtn);
	int nState = pBtn->GetState();

	cecnetOne_Put(g_nOutStart+15, nState);
}

void CPE_TEST_PROGDlg::OnMouseUpTgbtn16(short Button, short Shift, long x, long y) 
{
	CComiToggleSwitch *pBtn = NULL;
	GetBtnFromIdx(16, pBtn);
	int nState = pBtn->GetState();

	cecnetOne_Put(g_nOutStart+16, nState);
}

void CPE_TEST_PROGDlg::OnMouseUpTgbtn17(short Button, short Shift, long x, long y) 
{
	CComiToggleSwitch *pBtn = NULL;
	GetBtnFromIdx(17, pBtn);
	int nState = pBtn->GetState();

	cecnetOne_Put(g_nOutStart+17, nState);
}

void CPE_TEST_PROGDlg::OnMouseUpTgbtn18(short Button, short Shift, long x, long y) 
{
	CComiToggleSwitch *pBtn = NULL;
	GetBtnFromIdx(18, pBtn);
	int nState = pBtn->GetState();

	cecnetOne_Put(g_nOutStart+18, nState);
}

void CPE_TEST_PROGDlg::OnMouseUpTgbtn19(short Button, short Shift, long x, long y) 
{
	CComiToggleSwitch *pBtn = NULL;
	GetBtnFromIdx(19, pBtn);
	int nState = pBtn->GetState();

	cecnetOne_Put(g_nOutStart+19, nState);
}

void CPE_TEST_PROGDlg::OnMouseUpTgbtn20(short Button, short Shift, long x, long y) 
{
	CComiToggleSwitch *pBtn = NULL;
	GetBtnFromIdx(20, pBtn);
	int nState = pBtn->GetState();

	cecnetOne_Put(g_nOutStart+20, nState);
}

void CPE_TEST_PROGDlg::OnMouseUpTgbtn21(short Button, short Shift, long x, long y) 
{
	CComiToggleSwitch *pBtn = NULL;
	GetBtnFromIdx(21, pBtn);
	int nState = pBtn->GetState();

	cecnetOne_Put(g_nOutStart+21, nState);
}

void CPE_TEST_PROGDlg::OnMouseUpTgbtn22(short Button, short Shift, long x, long y) 
{
	CComiToggleSwitch *pBtn = NULL;
	GetBtnFromIdx(22, pBtn);
	int nState = pBtn->GetState();

	cecnetOne_Put(g_nOutStart+22, nState);
}

void CPE_TEST_PROGDlg::OnMouseUpTgbtn23(short Button, short Shift, long x, long y) 
{
	CComiToggleSwitch *pBtn = NULL;
	GetBtnFromIdx(23, pBtn);
	int nState = pBtn->GetState();

	cecnetOne_Put(g_nOutStart+23, nState);
}

void CPE_TEST_PROGDlg::OnMouseUpTgbtn24(short Button, short Shift, long x, long y) 
{
	CComiToggleSwitch *pBtn = NULL;
	GetBtnFromIdx(24, pBtn);
	int nState = pBtn->GetState();

	cecnetOne_Put(g_nOutStart+24, nState);
}

void CPE_TEST_PROGDlg::OnMouseUpTgbtn25(short Button, short Shift, long x, long y) 
{
	CComiToggleSwitch *pBtn = NULL;
	GetBtnFromIdx(25, pBtn);
	int nState = pBtn->GetState();

	cecnetOne_Put(g_nOutStart+25, nState);
}

void CPE_TEST_PROGDlg::OnMouseUpTgbtn26(short Button, short Shift, long x, long y) 
{
	CComiToggleSwitch *pBtn = NULL;
	GetBtnFromIdx(26, pBtn);
	int nState = pBtn->GetState();

	cecnetOne_Put(g_nOutStart+26, nState);
}

void CPE_TEST_PROGDlg::OnMouseUpTgbtn27(short Button, short Shift, long x, long y) 
{
	CComiToggleSwitch *pBtn = NULL;
	GetBtnFromIdx(27, pBtn);
	int nState = pBtn->GetState();

	cecnetOne_Put(g_nOutStart+27, nState);
}

void CPE_TEST_PROGDlg::OnMouseUpTgbtn28(short Button, short Shift, long x, long y) 
{
	CComiToggleSwitch *pBtn = NULL;
	GetBtnFromIdx(28, pBtn);
	int nState = pBtn->GetState();

	cecnetOne_Put(g_nOutStart+28, nState);
}

void CPE_TEST_PROGDlg::OnMouseUpTgbtn29(short Button, short Shift, long x, long y) 
{
	CComiToggleSwitch *pBtn = NULL;
	GetBtnFromIdx(29, pBtn);
	int nState = pBtn->GetState();

	cecnetOne_Put(g_nOutStart+29, nState);
}

void CPE_TEST_PROGDlg::OnMouseUpTgbtn30(short Button, short Shift, long x, long y) 
{
	CComiToggleSwitch *pBtn = NULL;
	GetBtnFromIdx(30, pBtn);
	int nState = pBtn->GetState();

	cecnetOne_Put(g_nOutStart+30, nState);
}

void CPE_TEST_PROGDlg::OnMouseUpTgbtn31(short Button, short Shift, long x, long y) 
{
	CComiToggleSwitch *pBtn = NULL;
	GetBtnFromIdx(31, pBtn);
	int nState = pBtn->GetState();

	cecnetOne_Put(g_nOutStart+31, nState);
}

void CPE_TEST_PROGDlg::OnMouseUpTgbtnOdd(short Button, short Shift, long x, long y) 
{
	cecnetMulti_Put(g_nOutStart+0, 32, 0xAAAAAAAA);

	CComiToggleSwitch *pMyBtn;
	for(int i=0; i<32; i++){
		GetBtnFromIdx(i, pMyBtn);
		if(i%2 == 1){
			pMyBtn->SetState(1);
		}else{
			pMyBtn->SetState(0);
		}
	}

	g_uToggleMode = TM_ODD;
}

void CPE_TEST_PROGDlg::OnMouseUpTgbtnEven(short Button, short Shift, long x, long y) 
{
	cecnetMulti_Put(g_nOutStart+0, 32, 0x55555555);

	CComiToggleSwitch *pMyBtn;
	for(int i=0; i<32; i++){
		GetBtnFromIdx(i, pMyBtn);
		if(i%2 == 0){
			pMyBtn->SetState(1);
		}else{
			pMyBtn->SetState(0);
		}
	}

	g_uToggleMode = TM_EVEN;
}

void CPE_TEST_PROGDlg::OnMouseUpTgbtnAllon(short Button, short Shift, long x, long y) 
{
	cecnetMulti_Put(g_nOutStart+0, 32, 0xFFFFFFFF);
	
	CComiToggleSwitch *pMyBtn;
	for(int i=0; i<32; i++){
		GetBtnFromIdx(i, pMyBtn);
		pMyBtn->SetState(1);
	}

	g_uToggleMode = TM_ALLON;
}

void CPE_TEST_PROGDlg::OnMouseUpTgbtnAlloff(short Button, short Shift, long x, long y) 
{
	cecnetMulti_Put(g_nOutStart+0, 32, 0x0);

	CComiToggleSwitch *pMyBtn;
	for(int i=0; i<32; i++){
		GetBtnFromIdx(i, pMyBtn);
		pMyBtn->SetState(0);
	}

	g_uToggleMode = TM_ALLOFF;
}

void CPE_TEST_PROGDlg::OnMouseUpTgbtnQuit(short Button, short Shift, long x, long y) 
{
	if(MessageBox(" Ͻðڽϱ?", "α׷  Ȯ", MB_YESNO) == IDYES)
	{
		SendMessage(WM_CLOSE);
	}
}

TVINSERTSTRUCT *tvi0 = NULL;
void CPE_TEST_PROGDlg::OnMouseUpScannode(short Button, short Shift, long x, long y) 
{
#define MAX_NODES	20

	BeginWaitCursor();
	ceGnSearchDevice(2, 2000, FALSE, &g_nTotNodes);
	ceGnReSearchDevice(2, 2000, FALSE, &g_nTotNodes);
	EndWaitCursor();

	if(g_nTotNodes < 1)
	{
		AfxMessageBox("˻ 尡 ϳ ϴ! Ʈũ  Ȯ ϼ");
		return;
	}

	cemAdvGetAllNodeInformation(&g_CurrentNodeInformation);

	g_nTot0032 = g_nTot3200 = g_nTot0024 = g_nTot0016 = g_nTot1600 = g_nTot1616 = g_nTot0808 = 0;
	g_nTotCM01A = g_nTotCNetSlaves = 0;

	CString sVal, sVal2;

	UINT uModType;
	int i, j, k, nNodeIdx=0;
	HTREEITEM ahTreeRoot[MAX_NODES];
	m_treeNodeInfo.DeleteAllItems();

	tvi0 = new TVINSERTSTRUCT;

	for(i = 0; i < g_CurrentNodeInformation.TotalNodeCount; i++)
	{
		if((g_CurrentNodeInformation.Node[i].IpAddress & 0xc0a80100) != 0xc0a80100 ) continue; // [2014.07.18] IP Address  192.168.1.x  ƴϸ skip

		//TVINSERTSTRUCT tvi0;
		tvi0->hParent = TVI_ROOT;
		tvi0->hInsertAfter = TVI_LAST;
		tvi0->item.mask = TVIF_TEXT;
		sVal.Format("Node: 192.168.1.%d", g_CurrentNodeInformation.Node[i].ID);
		tvi0->item.pszText = sVal.GetBuffer(sVal.GetLength());

		tvi0->item.lParam = 100;

		ahTreeRoot[nNodeIdx] = m_treeNodeInfo.InsertItem(tvi0);

		g_nTotCNetSlaves += g_CurrentNodeInformation.Node[i].CNETMasterModule->nTotalCNetModule;
		g_nTotCM01A += g_CurrentNodeInformation.Node[i].TotalCNETMasterModule;

		for(j=0; j<g_nTotCNetSlaves; j++){
			switch(g_CurrentNodeInformation.Node[i].CNETMasterModule->CNetModule[j].nModuleType)
			{
			case 0:
				g_nTot0032 += 1;
				break;
			case 1:
				g_nTot0808 += 1;
				break;
			case 2:
				g_nTot1616 += 1;
				break;
			case 3:
				g_nTot1600 += 1;
				break;
			case 4:
				g_nTot3200 += 1;
				break;
			case 5:
				g_nTot0016 += 1;
				break;
			case 6: // [fixme]
				g_nTot0024 += 1;
				break;
			}
		}

		int nBeginInChIdx=0, nEndInChIdx=0;
		int nBeginOutChIdx=0, nEndOutChIdx=0;
		for(j=0; j<g_CurrentNodeInformation.Node[i].TotalCNETMasterModule; j++)
		{
			TVINSERTSTRUCT tvi1;
			tvi1.hParent = ahTreeRoot[nNodeIdx];
			tvi1.hInsertAfter = TVI_LAST;
			tvi1.item.mask = TVIF_TEXT;

			sVal.Format("ceCM01A [%d]", g_CurrentNodeInformation.Node[i].CNETMasterModule[j].nModuleNumber);
			tvi1.item.pszText = sVal.GetBuffer(sVal.GetLength());
			HTREEITEM hTreeLevel1 = m_treeNodeInfo.InsertItem(&tvi1);

			int nDoCnt = 0;
			int nDiCnt = 0;
			for(k=0; k<g_CurrentNodeInformation.Node[i].CNETMasterModule[j].nTotalCNetModule; k++)
			{
				TVINSERTSTRUCT tvi2;
				tvi2.hParent = hTreeLevel1;
				tvi2.hInsertAfter = TVI_LAST;
				tvi2.item.mask = TVIF_TEXT;

				// Node Type ( 000-00_32, 001-8_8, 010-16_16, 011-16_00, 100-32_00, 101-00_16, 110-00_24 )
				uModType = g_CurrentNodeInformation.Node[i].CNETMasterModule[j].CNetModule[k].nModuleType;
				if(uModType == 0){
					nBeginInChIdx=0, nEndInChIdx=0;
					nBeginOutChIdx=0, nEndOutChIdx=0;
					sVal2.Format("[%d]cnD?00-32 [Out: %d-%d]", k, nDoCnt, nDoCnt+31);
					g_tCNetSlaveInfo[k].nType = 1; // output
					g_tCNetSlaveInfo[k].nStartOutputCh = nDoCnt;
					g_tCNetSlaveInfo[k].nEndOutputCh = nDoCnt+31;

					nDoCnt += 32;
					tvi2.item.lParam = 1;
				}else if(uModType == 1){
					sVal2.Format("[%d]cnD?08-08 [In: %d-%d, Out: %d-%d]", k, nDiCnt, nDiCnt+7, nDoCnt, nDoCnt+7);
					g_tCNetSlaveInfo[k].nType = 2; // in/out
					g_tCNetSlaveInfo[k].nStartInputCh = nDiCnt;
					g_tCNetSlaveInfo[k].nEndInputCh = nDiCnt+7;
					g_tCNetSlaveInfo[k].nStartOutputCh = nDoCnt;
					g_tCNetSlaveInfo[k].nEndOutputCh = nDoCnt+7;

					nDiCnt += 8;
					nDoCnt += 8;
					tvi2.item.lParam = 2;
				}else if(uModType == 2){
					sVal2.Format("[%d]cnD?16-16 [In: %d-%d, Out: %d-%d]", k, nDiCnt, nDiCnt+15, nDoCnt, nDoCnt+15);
					g_tCNetSlaveInfo[k].nType = 2; // in/out
					g_tCNetSlaveInfo[k].nStartInputCh = nDiCnt;
					g_tCNetSlaveInfo[k].nEndInputCh = nDiCnt+15;
					g_tCNetSlaveInfo[k].nStartOutputCh = nDoCnt;
					g_tCNetSlaveInfo[k].nEndOutputCh = nDoCnt+15;

					nDiCnt += 16;
					nDoCnt += 16;
					tvi2.item.lParam = 3;
				}else if(uModType == 3){
					sVal2.Format("[%d]cnD?16-00 [In: %d-%d]", k, nDiCnt, nDiCnt+15);
					g_tCNetSlaveInfo[k].nType = 0; // input
					g_tCNetSlaveInfo[k].nStartInputCh = nDiCnt;
					g_tCNetSlaveInfo[k].nEndInputCh = nDiCnt+15;

					nDiCnt += 16;
					tvi2.item.lParam = 4;
				}else if(uModType == 4){
					sVal2.Format("[%d]cnD?32-00 [In: %d-%d]", k, nDiCnt, nDiCnt+31);
					g_tCNetSlaveInfo[k].nType = 0; // input
					g_tCNetSlaveInfo[k].nStartInputCh = nDiCnt;
					g_tCNetSlaveInfo[k].nEndInputCh = nDiCnt+31;

					nDiCnt += 32;
					tvi2.item.lParam = 5;
				}else if(uModType == 5){
					sVal2.Format("[%d]cnD?00-16 [Out: %d-%d]", k, nDoCnt, nDoCnt+15);
					g_tCNetSlaveInfo[k].nType = 1; // output
					g_tCNetSlaveInfo[k].nStartOutputCh = nDoCnt;
					g_tCNetSlaveInfo[k].nEndOutputCh = nDoCnt+15;

					nDoCnt += 16;
					tvi2.item.lParam = 6;
				}else if(uModType == 6){
					sVal2.Format("[%d]cnD?00-24 [Out: %d-%d]", k, nDoCnt, nDoCnt+23);
					g_tCNetSlaveInfo[k].nType = 1; // output
					g_tCNetSlaveInfo[k].nStartOutputCh = nDoCnt;
					g_tCNetSlaveInfo[k].nEndOutputCh = nDoCnt+23;

					nDoCnt += 24;
					tvi2.item.lParam = 7;
				}else{
					continue;
				}

				sVal.Format("%s  [#%d]", sVal2, g_CurrentNodeInformation.Node[i].CNETMasterModule[j].CNetModule[k].nModuleNumber);
				tvi2.item.pszText = sVal.GetBuffer(sVal.GetLength());
				HTREEITEM hTreeLevel2 = m_treeNodeInfo.InsertItem(&tvi2);

				m_treeNodeInfo.Expand(hTreeLevel1, TVE_EXPAND);
			}
		}

		for(j=0; j<g_CurrentNodeInformation.Node[i].TotalAIModule; j++)
		{
			TVINSERTSTRUCT tvi1;
			tvi1.hParent = ahTreeRoot[nNodeIdx];
			tvi1.hInsertAfter = TVI_LAST;
			tvi1.item.mask = TVIF_TEXT;

			sVal.Format("ceAI08A [%d]", g_CurrentNodeInformation.Node[i].AIModule[j].nModuleNumber);
			tvi1.item.pszText = sVal.GetBuffer(sVal.GetLength());
			HTREEITEM hTreeLevel1 = m_treeNodeInfo.InsertItem(&tvi1);
		}

		for(j=0; j<g_CurrentNodeInformation.Node[i].TotalAOModule; j++)
		{
			TVINSERTSTRUCT tvi1;
			tvi1.hParent = ahTreeRoot[nNodeIdx];
			tvi1.hInsertAfter = TVI_LAST;
			tvi1.item.mask = TVIF_TEXT;

			sVal.Format("ceAO02 [%d]", g_CurrentNodeInformation.Node[i].AOModule[j].nModuleNumber);
			tvi1.item.pszText = sVal.GetBuffer(sVal.GetLength());
			HTREEITEM hTreeLevel1 = m_treeNodeInfo.InsertItem(&tvi1);
		}

		for(j=0; j<g_CurrentNodeInformation.Node[i].TotalCNTModule; j++)
		{
			TVINSERTSTRUCT tvi1;
			tvi1.hParent = ahTreeRoot[nNodeIdx];
			tvi1.hInsertAfter = TVI_LAST;
			tvi1.item.mask = TVIF_TEXT;

			sVal.Format("ceCN08A [%d]", g_CurrentNodeInformation.Node[i].CNTModule[j].nModuleNumber);
			tvi1.item.pszText = sVal.GetBuffer(sVal.GetLength());
			HTREEITEM hTreeLevel1 = m_treeNodeInfo.InsertItem(&tvi1);
		}

		for(j=0; j<g_CurrentNodeInformation.Node[i].TotalDIOModule; j++)
		{
			TVINSERTSTRUCT tvi1;
			tvi1.hParent = ahTreeRoot[nNodeIdx];
			tvi1.hInsertAfter = TVI_LAST;
			tvi1.item.mask = TVIF_TEXT;

			uModType = g_CurrentNodeInformation.Node[i].DIOModule[j].nModuleType;
			if(uModType == 0){
				sVal2.Format("ceDI32N");
			}else if(uModType == 1){
				sVal2.Format("ceDO32N");
			}else if(uModType == 5){
				sVal2.Format("ceD16CM");
			}else{
				continue;
			}

			sVal.Format("%s [%d]", sVal2, g_CurrentNodeInformation.Node[i].DIOModule[j].nModuleNumber);
			tvi1.item.pszText = sVal.GetBuffer(sVal.GetLength());
			HTREEITEM hTreeLevel1 = m_treeNodeInfo.InsertItem(&tvi1);
		}

		for(j=0; j<g_CurrentNodeInformation.Node[i].TotalMotModule; j++)
		{
			TVINSERTSTRUCT tvi1;
			tvi1.hParent = ahTreeRoot[nNodeIdx];
			tvi1.hInsertAfter = TVI_LAST;
			tvi1.item.mask = TVIF_TEXT;

			sVal.Format("ceMC02P [%d]", g_CurrentNodeInformation.Node[i].MotModule[j].nModuleNumber);
			tvi1.item.pszText = sVal.GetBuffer(sVal.GetLength());
			HTREEITEM hTreeLevel1 = m_treeNodeInfo.InsertItem(&tvi1);
		}

		m_treeNodeInfo.Expand(ahTreeRoot[nNodeIdx], TVE_EXPAND);
		nNodeIdx++;
	}	

	g_nTotnDiChNum = g_nTot3200 * 32 + g_nTot1600 * 16 + g_nTot1616 * 16 + g_nTot0808 * 8;
	g_nTotnDoChNum = g_nTot0032 * 32 + g_nTot0024 * 24 + g_nTot1616 * 16 + g_nTot0808 * 8;

	InitGui(IGT_AIO);

#undef MAX_NODES
}

BOOL CPE_TEST_PROGDlg::GetLedFromIdx(int idx, CCOMILed *&poLed)
{
	switch (idx)
	{
	case 0:
		poLed = &m_ledCh00;
		return TRUE;
	case 1:
		poLed = &m_ledCh01;
		return TRUE;
	case 2:
		poLed = &m_ledCh02;
		return TRUE;
	case 3:
		poLed = &m_ledCh03;
		return TRUE;
	case 4:
		poLed = &m_ledCh04;
		return TRUE;
	case 5:
		poLed = &m_ledCh05;
		return TRUE;
	case 6:
		poLed = &m_ledCh06;
		return TRUE;
	case 7:
		poLed = &m_ledCh07;
		return TRUE;
	case 8:
		poLed = &m_ledCh08;
		return TRUE;
	case 9:
		poLed = &m_ledCh09;
		return TRUE;
	case 10:
		poLed = &m_ledCh10;
		return TRUE;
	case 11:
		poLed = &m_ledCh11;
		return TRUE;
	case 12:
		poLed = &m_ledCh12;
		return TRUE;
	case 13:
		poLed = &m_ledCh13;
		return TRUE;
	case 14:
		poLed = &m_ledCh14;
		return TRUE;
	case 15:
		poLed = &m_ledCh15;
		return TRUE;
	case 16:
		poLed = &m_ledCh16;
		return TRUE;
	case 17:
		poLed = &m_ledCh17;
		return TRUE;
	case 18:
		poLed = &m_ledCh18;
		return TRUE;
	case 19:
		poLed = &m_ledCh19;
		return TRUE;
	case 20:
		poLed = &m_ledCh20;
		return TRUE;
	case 21:
		poLed = &m_ledCh21;
		return TRUE;
	case 22:
		poLed = &m_ledCh22;
		return TRUE;
	case 23:
		poLed = &m_ledCh23;
		return TRUE;
	case 24:
		poLed = &m_ledCh24;
		return TRUE;
	case 25:
		poLed = &m_ledCh25;
		return TRUE;
	case 26:
		poLed = &m_ledCh26;
		return TRUE;
	case 27:
		poLed = &m_ledCh27;
		return TRUE;
	case 28:
		poLed = &m_ledCh28;
		return TRUE;
	case 29:
		poLed = &m_ledCh29;
		return TRUE;
	case 30:
		poLed = &m_ledCh30;
		return TRUE;
	case 31:
		poLed = &m_ledCh31;
		return TRUE;
	default:
		poLed = NULL;
		return FALSE;
	}
}

BOOL CPE_TEST_PROGDlg::GetBtnFromIdx(int idx, CComiToggleSwitch *&poBtn)
{
	switch (idx)
	{
	case 0:
		poBtn = &m_btnCh00;
		return TRUE;
	case 1:
		poBtn = &m_btnCh01;
		return TRUE;
	case 2:
		poBtn = &m_btnCh02;
		return TRUE;
	case 3:
		poBtn = &m_btnCh03;
		return TRUE;
	case 4:
		poBtn = &m_btnCh04;
		return TRUE;
	case 5:
		poBtn = &m_btnCh05;
		return TRUE;
	case 6:
		poBtn = &m_btnCh06;
		return TRUE;
	case 7:
		poBtn = &m_btnCh07;
		return TRUE;
	case 8:
		poBtn = &m_btnCh08;
		return TRUE;
	case 9:
		poBtn = &m_btnCh09;
		return TRUE;
	case 10:
		poBtn = &m_btnCh10;
		return TRUE;
	case 11:
		poBtn = &m_btnCh11;
		return TRUE;
	case 12:
		poBtn = &m_btnCh12;
		return TRUE;
	case 13:
		poBtn = &m_btnCh13;
		return TRUE;
	case 14:
		poBtn = &m_btnCh14;
		return TRUE;
	case 15:
		poBtn = &m_btnCh15;
		return TRUE;
	case 16:
		poBtn = &m_btnCh16;
		return TRUE;
	case 17:
		poBtn = &m_btnCh17;
		return TRUE;
	case 18:
		poBtn = &m_btnCh18;
		return TRUE;
	case 19:
		poBtn = &m_btnCh19;
		return TRUE;
	case 20:
		poBtn = &m_btnCh20;
		return TRUE;
	case 21:
		poBtn = &m_btnCh21;
		return TRUE;
	case 22:
		poBtn = &m_btnCh22;
		return TRUE;
	case 23:
		poBtn = &m_btnCh23;
		return TRUE;
	case 24:
		poBtn = &m_btnCh24;
		return TRUE;
	case 25:
		poBtn = &m_btnCh25;
		return TRUE;
	case 26:
		poBtn = &m_btnCh26;
		return TRUE;
	case 27:
		poBtn = &m_btnCh27;
		return TRUE;
	case 28:
		poBtn = &m_btnCh28;
		return TRUE;
	case 29:
		poBtn = &m_btnCh29;
		return TRUE;
	case 30:
		poBtn = &m_btnCh30;
		return TRUE;
	case 31:
		poBtn = &m_btnCh31;
		return TRUE;
	default:
		poBtn = NULL;
		return FALSE;
	}
}

void CPE_TEST_PROGDlg::OnDestroy() 
{
	g_bThreadStop = TRUE;

	KillTimer(0);
	timeKillEvent(g_idEvent1);

	ceGnUnload();
	ceUnloadDll();	

	CDialog::OnDestroy();
}	


void CPE_TEST_PROGDlg::OnSelchangedTreeNodeinfo(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_TREEVIEW* pNMTreeView = (NM_TREEVIEW*)pNMHDR;

	HTREEITEM hItem = pNMTreeView->itemNew.hItem;

	CString sData = m_treeNodeInfo.GetItemText(hItem);

	int nStart = sData.Find("[", 0);
	int nEnd = sData.Find("]", 0);
	

	char sModIdx[10];
	memset(sModIdx, 0, 10);

	for(int i=0; i<(nEnd-nStart); i++)
	{
		sModIdx[i] = sData[nStart+i+1];
	}
	int nModIdx = atoi(sModIdx);

	if(nModIdx < 0 || nModIdx >= MAX_MOD) return;
	
	if(g_tCNetSlaveInfo[nModIdx].nType == 0) // input
	{
		g_nInStart = g_tCNetSlaveInfo[nModIdx].nStartInputCh;
		g_nInEnd = g_tCNetSlaveInfo[nModIdx].nEndInputCh;
	}
	else if(g_tCNetSlaveInfo[nModIdx].nType == 1) // output
	{
		g_nOutStart = g_tCNetSlaveInfo[nModIdx].nStartOutputCh;
		g_nOutEnd = g_tCNetSlaveInfo[nModIdx].nEndOutputCh;
	}
	else if(g_tCNetSlaveInfo[nModIdx].nType == 2) // in/out
	{
		g_nInStart = g_tCNetSlaveInfo[nModIdx].nStartInputCh;
		g_nInEnd = g_tCNetSlaveInfo[nModIdx].nEndInputCh;
		g_nOutStart = g_tCNetSlaveInfo[nModIdx].nStartOutputCh;
		g_nOutEnd = g_tCNetSlaveInfo[nModIdx].nEndOutputCh;
	}

	UpdateChannelView();

	*pResult = 0;
}


void CPE_TEST_PROGDlg::UpdateChannelView()
{
	int i;
	CString sVal;
	sVal.Format("C-NET Digital Input Channels : [%d-%d]", g_nInStart, g_nInEnd);
	m_grpCnetDi.SetWindowText(sVal);

	CCOMILed *pLed = NULL;
	for(i=0; i<32; i++){
		GetLedFromIdx(i, pLed);
		sVal.Format("%d", g_nInStart + i);
		pLed->SetStateText(sVal);
	}

	sVal.Format("C-NET Digital Output Channels : [%d-%d]", g_nOutStart, g_nOutEnd);
	m_grpCnetDo.SetWindowText(sVal);

	CComiToggleSwitch *pBtn = NULL;
	for(i=0; i<32; i++){
		GetBtnFromIdx(i, pBtn);
		sVal.Format("%d", g_nOutStart + i);
		pBtn->SetOnText(sVal);
		pBtn->SetOffText(sVal);
	}
}

void CPE_TEST_PROGDlg::OnButton1() 
{
	// TODO: Add your control notification handler code here
	long DOStateMask,DIStateMask;
	int i;
	
	DWORD dwStartT, dwEllapsedT1, dwEllapsedT2, dwEllapsedT3, dwEllapsedT4;

	dwStartT = timeGetTime();  // #include <mmsystem.h> ߰Ǿ .

	for(i=0; i<100; i++)
	{	
	cecnetDIOne_Get(i,&DOStateMask);
	}

	dwEllapsedT1 = timeGetTime() - dwStartT; // ⿡ Break Point  ȮϽø ȵ˴ϴ.  ο Break Point  ҿð(Ellapsed  Ȯ ϼ)


	dwStartT = timeGetTime();
	
	for(i=0; i<100; i++)
	{
	cecnetDIMulti_Get(i,32,&DOStateMask);
	}

	dwEllapsedT2 = timeGetTime() - dwStartT; // ⿡ Break Point  ȮϽø ȵ˴ϴ.  ο Break Point  ҿð(Ellapsed  Ȯ ϼ)

	
	dwStartT = timeGetTime();
	
	for(i=0; i<100; i++)
	{	
	cecnetDOOne_Get(i,&DOStateMask);
	}

	dwEllapsedT3 = timeGetTime() - dwStartT; // ⿡ Break Point  ȮϽø ȵ˴ϴ.  ο Break Point  ҿð(Ellapsed  Ȯ ϼ)

	
	dwStartT = timeGetTime();

	for(i=0; i<100; i++)
	{
	cecnetDOMulti_Get(i,32,&DOStateMask);
	}

	dwEllapsedT4 = timeGetTime() - dwStartT; // ⿡ Break Point  ȮϽø ȵ˴ϴ.  ο Break Point  ҿð(Ellapsed  Ȯ ϼ)

	UpdateData(FALSE);







/*
	//m_DiState.Format("%d",DIStateMask);
	//m_DoState.Format("%d",DOStateMask);	

#define AXIS_CNT	25

	CString sVal;
	long anIsDone[AXIS_CNT];
	long anMotState[AXIS_CNT];
	long anMioState[AXIS_CNT];
	long multiDI, multiDO;

	dwStartT = timeGetTime();  // #include <mmsystem.h> ߰Ǿ .
	/*for(int i=0; i<AXIS_CNT; i++)
	{
		cemSxIsDone(i, &anIsDone[i]);
		cemStReadMotionState(i, &anMotState[i]);
		cemStReadMioStatuses(i, &anMioState[i]);

		if(((anMioState[i] >> cemIOST_ALM) & 0x1) == 0x1) // ˶ ߻.
		{
			sVal.Format("Axis%d  ˶ ߻!", i);
			AfxMessageBox(sVal);
		}
		
	}*/






	
	
}
