// PE_TEST_PROGDlg.h : header file
//
//{{AFX_INCLUDES()
#include "comigraph.h"
#include "comitoggleswitch.h"
#include "comiled.h"
//}}AFX_INCLUDES

#include "MyToggleWnd.h"
#include "IoMapDlg.h"

//  

// 1. I/O Sensor Port : Out 15(Normal Low) Only
enum _TIoSensorPortOut {	DO_IOSENSOR_PORT00 = 0, DO_IOSENSOR_PORT01, DO_IOSENSOR_PORT02, DO_IOSENSOR_PORT03, DO_IOSENSOR_PORT04, DO_IOSENSOR_PORT05,
							DO_IOSENSOR_PORT06, DO_IOSENSOR_PORT07, DO_IOSENSOR_PORT08, DO_IOSENSOR_PORT09, DO_IOSENSOR_PORT10, DO_IOSENSOR_PORT11,
							DO_IOSENSOR_PORT12, DO_IOSENSOR_PORT13, DO_IOSENSOR_PORT14 = 14 };

// 2. Leak Inter Lock : Out 6(Normal Low) Only
enum _TLeakInterlockOut {	DO_LEAK_INTERLOCK00 = 15, DO_LEAK_INTERLOCK01, DO_LEAK_INTERLOCK02, DO_LEAK_INTERLOCK03, DO_LEAK_INTERLOCK04, DO_LEAK_INTERLOCK05 = 20 };

// 3. Watchdog Pulse IN/OUT : Out 1(Pulse Type), In 1(Pulse Type) Ȯ
enum _TWatchdogPulseInOut {	DIO_WATCHDOG_PULSE00 = 21 };

// 4. EXT TST : In 1(Normal Low) Ȯ Only
enum _TExtTstIn {	DI_EXT_TST00 = 22 };

// 5. EXT Soft Trip : Out 1(Normal High) Only,  CP401 ÿ cnD00-32 θ ÿ   ǰ  ä ȣ ޶ 
enum _TExtSoftTripOut { DO_EXT_SOFTTRIP00 = 23 };

// 6. Debug Mode : In 1(Normal High) Ȯ Only
enum _TDebugModeIn { DI_DBGMODE00 = 24 };

// 7. Trip(Relay ON/OFF) In/Out : Out 3(Normal High), In 3(Normal High) Ȯ
enum _TTripRelayInOut { DIO_TRIP_RELAY00 = 25, DIO_TRIP_RELAY01, DIO_TRIP_RELAY02 = 27 };

#if !defined(AFX_PE_TEST_PROGDLG_H__5B2E1DE5_0390_4C57_96DD_174A91D1DC88__INCLUDED_)
#define AFX_PE_TEST_PROGDLG_H__5B2E1DE5_0390_4C57_96DD_174A91D1DC88__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// CPE_TEST_PROGDlg dialog

class CPE_TEST_PROGDlg : public CDialog
{
// Construction
public:
	void UpdateChannelView();
	BOOL GetBtnFromIdx(int idx, CComiToggleSwitch *&poBtn);
	CPE_TEST_PROGDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CPE_TEST_PROGDlg)
	enum { IDD = IDD_PE_TEST_PROG_DIALOG };
	CButton	m_grpCnetDo;
	CButton	m_grpCnetDi;
	CListBox	m_lstLog;
	CMyToggleWnd	m_wndTripRelay2;
	CEdit	m_edtWatchdogPulseDuration;
	CMyToggleWnd	m_wndExtTst;
	CMyToggleWnd	m_wndDebugMode;
	CMyToggleWnd	m_wndWatchDogPulse;
	CMyToggleWnd	m_wndTripRelay;
	CTreeCtrl	m_treeNodeInfo;
	CButton	m_chkToggleLed;
	CComiToggleSwitch	m_tgbtnAdStartStop;
	CCOMILed	m_ledCh00;
	CCOMILed	m_ledCh01;
	CCOMILed	m_ledCh02;
	CCOMILed	m_ledCh03;
	CCOMILed	m_ledCh04;
	CCOMILed	m_ledCh05;
	CCOMILed	m_ledCh06;
	CCOMILed	m_ledCh07;
	CCOMILed	m_ledCh08;
	CCOMILed	m_ledCh09;
	CCOMILed	m_ledCh10;
	CCOMILed	m_ledCh11;
	CCOMILed	m_ledCh12;
	CCOMILed	m_ledCh13;
	CCOMILed	m_ledCh14;
	CCOMILed	m_ledCh15;
	CCOMILed	m_ledCh16;
	CCOMILed	m_ledCh17;
	CCOMILed	m_ledCh18;
	CCOMILed	m_ledCh19;
	CCOMILed	m_ledCh20;
	CCOMILed	m_ledCh21;
	CCOMILed	m_ledCh22;
	CCOMILed	m_ledCh23;
	CCOMILed	m_ledCh24;
	CCOMILed	m_ledCh25;
	CCOMILed	m_ledCh26;
	CCOMILed	m_ledCh27;
	CCOMILed	m_ledCh28;
	CCOMILed	m_ledCh29;
	CCOMILed	m_ledCh30;
	CCOMILed	m_ledCh31;
	CComiToggleSwitch	m_btnCh00;
	CComiToggleSwitch	m_btnCh01;
	CComiToggleSwitch	m_btnCh02;
	CComiToggleSwitch	m_btnCh03;
	CComiToggleSwitch	m_btnCh04;
	CComiToggleSwitch	m_btnCh05;
	CComiToggleSwitch	m_btnCh06;
	CComiToggleSwitch	m_btnCh07;
	CComiToggleSwitch	m_btnCh08;
	CComiToggleSwitch	m_btnCh09;
	CComiToggleSwitch	m_btnCh10;
	CComiToggleSwitch	m_btnCh11;
	CComiToggleSwitch	m_btnCh12;
	CComiToggleSwitch	m_btnCh13;
	CComiToggleSwitch	m_btnCh14;
	CComiToggleSwitch	m_btnCh15;
	CComiToggleSwitch	m_btnCh16;
	CComiToggleSwitch	m_btnCh17;
	CComiToggleSwitch	m_btnCh18;
	CComiToggleSwitch	m_btnCh19;
	CComiToggleSwitch	m_btnCh20;
	CComiToggleSwitch	m_btnCh21;
	CComiToggleSwitch	m_btnCh22;
	CComiToggleSwitch	m_btnCh23;
	CComiToggleSwitch	m_btnCh24;
	CComiToggleSwitch	m_btnCh25;
	CComiToggleSwitch	m_btnCh26;
	CComiToggleSwitch	m_btnCh27;
	CComiToggleSwitch	m_btnCh28;
	CComiToggleSwitch	m_btnCh29;
	CComiToggleSwitch	m_btnCh30;
	CComiToggleSwitch	m_btnCh31;
	CString	m_DiState;
	CString	m_DoState;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CPE_TEST_PROGDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CPE_TEST_PROGDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnMouseUpTgbtnResetnodeinfo(short Button, short Shift, long x, long y);
	afx_msg void OnMouseUpTgbtnOdd(short Button, short Shift, long x, long y);
	afx_msg void OnMouseUpTgbtnEven(short Button, short Shift, long x, long y);
	afx_msg void OnMouseUpTgbtnAllon(short Button, short Shift, long x, long y);
	afx_msg void OnMouseUpTgbtnAlloff(short Button, short Shift, long x, long y);
	afx_msg void OnMouseUpTgbtnQuit(short Button, short Shift, long x, long y);
	afx_msg void OnMouseUpScannode(short Button, short Shift, long x, long y);
	afx_msg void OnDestroy();
	afx_msg void OnSelchangedTreeNodeinfo(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnMouseUpTgbtn00(short Button, short Shift, long x, long y);
	afx_msg void OnMouseUpTgbtn01(short Button, short Shift, long x, long y);
	afx_msg void OnMouseUpTgbtn02(short Button, short Shift, long x, long y);
	afx_msg void OnMouseUpTgbtn03(short Button, short Shift, long x, long y);
	afx_msg void OnMouseUpTgbtn04(short Button, short Shift, long x, long y);
	afx_msg void OnMouseUpTgbtn05(short Button, short Shift, long x, long y);
	afx_msg void OnMouseUpTgbtn06(short Button, short Shift, long x, long y);
	afx_msg void OnMouseUpTgbtn07(short Button, short Shift, long x, long y);
	afx_msg void OnMouseUpTgbtn08(short Button, short Shift, long x, long y);
	afx_msg void OnMouseUpTgbtn09(short Button, short Shift, long x, long y);
	afx_msg void OnMouseUpTgbtn10(short Button, short Shift, long x, long y);
	afx_msg void OnMouseUpTgbtn11(short Button, short Shift, long x, long y);
	afx_msg void OnMouseUpTgbtn12(short Button, short Shift, long x, long y);
	afx_msg void OnMouseUpTgbtn13(short Button, short Shift, long x, long y);
	afx_msg void OnMouseUpTgbtn14(short Button, short Shift, long x, long y);
	afx_msg void OnMouseUpTgbtn15(short Button, short Shift, long x, long y);
	afx_msg void OnMouseUpTgbtn16(short Button, short Shift, long x, long y);
	afx_msg void OnMouseUpTgbtn17(short Button, short Shift, long x, long y);
	afx_msg void OnMouseUpTgbtn18(short Button, short Shift, long x, long y);
	afx_msg void OnMouseUpTgbtn19(short Button, short Shift, long x, long y);
	afx_msg void OnMouseUpTgbtn20(short Button, short Shift, long x, long y);
	afx_msg void OnMouseUpTgbtn21(short Button, short Shift, long x, long y);
	afx_msg void OnMouseUpTgbtn22(short Button, short Shift, long x, long y);
	afx_msg void OnMouseUpTgbtn23(short Button, short Shift, long x, long y);
	afx_msg void OnMouseUpTgbtn24(short Button, short Shift, long x, long y);
	afx_msg void OnMouseUpTgbtn25(short Button, short Shift, long x, long y);
	afx_msg void OnMouseUpTgbtn26(short Button, short Shift, long x, long y);
	afx_msg void OnMouseUpTgbtn27(short Button, short Shift, long x, long y);
	afx_msg void OnMouseUpTgbtn28(short Button, short Shift, long x, long y);
	afx_msg void OnMouseUpTgbtn29(short Button, short Shift, long x, long y);
	afx_msg void OnMouseUpTgbtn30(short Button, short Shift, long x, long y);
	afx_msg void OnMouseUpTgbtn31(short Button, short Shift, long x, long y);
	afx_msg void OnButton1();
	DECLARE_EVENTSINK_MAP()
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	BOOL GetLedFromIdx(int idx, CCOMILed *&poLed);
	void InitGui(UINT uType);

	CIoMapDlg *m_pIoMapDlg;
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_PE_TEST_PROGDLG_H__5B2E1DE5_0390_4C57_96DD_174A91D1DC88__INCLUDED_)
